<template>
  <div class="container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="文件名称" prop="fileName">
        <el-input
          v-model="queryParams.fileName"
          v-no-whitespace
          placeholder="请输入文件名称"
          maxlength="60"
          show-word-limit
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="审批状态" prop="status">
        <el-select v-model="queryParams.status">
          <el-option v-for="item in statusOptions" :key="item.value" :label="item.label" :value="item.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-button
        v-hasPermi="['system:consMaterial:add']"
        class="filter-item"
        size="mini"
        type="primary"
        icon="el-icon-edit"
        @click="handleAdd"
      >新增
      </el-button>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="list" @selection-change="handleSelectionChange">
      <el-table-column
        type="index"
        width="55"
        label="序号"
        align="center"
        :index="indexContinuous(queryParams.pageNum, queryParams.pageSize)"
      />
      <el-table-column label="文件名称" align="center" prop="fileName" />
      <el-table-column label="文件大小" align="center" prop="fileSize" />
      <el-table-column label="文件类型" align="center" prop="fileType" />
      <el-table-column label="申请时间" align="center" prop="createTime" />
      <el-table-column label="审批状态" align="center" prop="intoStatus">
        <template slot-scope="scope">
          <!-- 检查是否存在身份证号 -->
          <span v-if="scope.row.intoStatus">{{ updateStatus(scope.row.intoStatus)
            }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            @click="handleEdit(scope.row)"
            v-if="scope.row.intoStatus == '0' || scope.row.intoStatus == '4' || scope.row.intoStatus == '5'"
            v-hasPermi="['system:consMaterial:edit']"
          >编辑
          </el-button>
          <el-button
            size="mini"
            type="text"
            @click="submitApproval(scope.row)"
            v-if="scope.row.intoStatus == '0'"
            v-hasPermi="['system:consMaterial:edit']"
          >提交审核
          </el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleView(scope.row)"
            v-else-if="scope.row.intoStatus == '3' || scope.row.intoStatus == '2'"
            v-hasPermi="['system:consMaterial:edit']"
          >查看
          </el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleRevocation(scope.row)"
            v-else-if="scope.row.intoStatus == '1'"
            v-hasPermi="['system:consMaterial:edit']"
          >撤回
          </el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleAuditRecord(scope.row)"
            v-hasPermi="['system:audit:query']"
          >审核记录
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <el-dialog title="文件查看" :visible.sync="open" width="80%" top="5vh" append-to-body>
      <bns-kkFile-preview :items="fileList" />
    </el-dialog>


  </div>
</template>

<script>
import BnsKkFilePreview from '@/components/pro-tabs/bns-kkFile-preview.vue'
import { dictTableOption } from '@/api/tool/select'
import { getEnterFileList } from '@/api/pro/cons/materialList'
import { retractApproval } from '@/api/terminalEquipment/deviceInformation'
import { encryptCBC } from '@/utils/aescbc'
import { submitApproval } from '@/api/pro/admissionRequest'
import { getParams, indexContinuous } from '@/utils/bonus'

export default {
  name: 'Post',
  components: { 'bns-kkFile-preview': BnsKkFilePreview },
  data() {
    return {
      // 遮罩层
      loading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 工程表格数据
      list: [],
      items: {},
      fileList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        type:'2',
        fileName: undefined,
        status: undefined,
        proId: this.$store.state.user.thisIds.proId,
        consUuid: this.$store.state.user.thisIds.consUuid,
        supUuid: this.$store.state.user.thisIds.supUuid
      },
      statusOptions: [],
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
      auditStatusDict: {
        '0': '待提交',
        '1': '待审批',
        '2': '审批中',
        '3': '已通过',
        '4': '已驳回',
        '5': '已撤销'
      }
    }
  },
  created() {
    this.getList()
    this.getStatus();
  },
  methods: {
    indexContinuous,
    updateStatus(status) {
      return this.auditStatusDict[status]
    },
    /** 查询工程列表 */
    getList() {
      this.loading = true
      getEnterFileList(this.queryParams).then(response => {
        this.list = response.rows
        this.total = response.total
        this.loading = false
      })
    },
    getStatus() {
      const params = {
        dictType: 'sys_approval_state',
        dictValue: ''
      }
      dictTableOption(params).then(response => {
        this.statusOptions = response.data
      })
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {
        equipName: undefined,
        postSort: 0
      }
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.proId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.$router.push('/pro/apply/consMaterialApply/' + encryptCBC(JSON.stringify(
        {
          taskId: '',
          procInstId: '',
          showType: 1,
          isExamine: false,
          btnShow: false,
          finalCheck: '0',
          type: 'add'
        }
      )))
      // this.$router.push({
      //   path: '/pro/apply/consMaterialApply', query: {
      //     params: {
      //       taskId:'',
      //       procInstId:'',
      //       showType: 1,
      //       isExamine:false,
      //       btnShow:false,
      //       finalCheck: '0',
      //       type: 'add'
      //     }
      //   }
      // })
    },
    /** 查看按钮操作 */
    handleView(row) {
      this.$router.push('/pro/apply/consMaterialApply/' + encryptCBC(JSON.stringify(
        {
          taskId: row.taskId,
          procInstId: row.procInstId,
          uuid: row.uuid,
          showType: 1,
          isExamine: false,
          btnShow: false,
          finalCheck: row.finalCheck,
          type: 'view'
        }
      )))
    },
    /** 编辑按钮操作 */
    handleEdit(row) {
      this.$router.push('/pro/apply/consMaterialApply/' + encryptCBC(JSON.stringify(
        {
          taskId: row.taskId,
          procInstId: row.procInstId,
          uuid: row.uuid,
          showType: 1,
          isExamine: false,
          btnShow: false,
          finalCheck: row.finalCheck,
          type: 'edit'
        }
      )))
    },
    /** 撤回按钮操作 */
    handleRevocation(row) {
      const params = {
        uuid: row.uuid,
        taskId: row.taskId,
        procInstId: row.procInsId,
        taskType: '7'
      }
      let text = '是否撤回当前入场材料的数据项？'
      this.$modal.confirm(text).then(function() {
        return retractApproval(params)
      }).then(() => {
        this.getList()
        this.$modal.msgSuccess('撤回成功')
      }).catch(() => {
      })
    },
    /** 审核记录按钮操作 */
    handleAuditRecord(row) {
      this.$router.push("/flow/auditRecord/" + encryptCBC(JSON.stringify({
        taskId: row.taskId,
        checkType:'2'
      })));
    },
    getParams,
    submitApproval(row){
      const param = {
        ...this.getParams(),
        taskType: '7',
        taskId: row.taskId,
        uuid: row.uuid,
      }
      submitApproval(param).then(response => {
        console.log("response="+JSON.stringify(response))
        if (response.code === 200) {
          if (response.msg === '此审核类型未配置相对应的审核流，请联系管理员配置后再次提交'){
            this.$modal.msgError(response.msg)
          }else{
            this.$modal.msgSuccess('提交成功')
          }
          this.getList()
        } else {
          this.$message.error(response.msg)
          this.getList()
        }
      }).catch((error) =>{
        console.log("error="+JSON.stringify(error))
      })
    }
  }
}
</script>
<style>
.container {
  padding: 10px
}
</style>
